﻿ using BA.Core;
using BA.Core.Configuration;
using BA.Core.Configuration.Grid;
using BA.Core.Configuration.Grid.Columns;
using BA.Core.Configuration.Grid.Columns.Interfaces;
using BA.Core.Configuration.OrmEntityBase.EntityFields;
using BA.Core.CustomAttributes;
using BA.Core.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Web;

namespace $safeprojectname$.Configuration.Grid.Controls
{
    [Serializable]
    [Toolbox(EnumConfigurationType.GridConfigurationGuid)]
    public class DefaultValueTextColumn : GridDataColumnBase, IGridDataColumnControl
    {
        public DefaultValueTextColumn()
        {
            ColumnType = EnumColumnType.TextBox;
            ToolboxName = "Text mit Vorbelegung";
            Caption = "Text mit Vorbelegung";
            ControlInitName = "DefaultValueTextColumn";
            ToolboxGroupName = Constants.Designer.ToolboxGroups.Grid.Basic;
            Icon = Constants.Icons.Designer.Grid.TextBox;
            Id = "D5B832E4-7D29-492D-B2C1-21306D168D74".ToGuid();
        }

        [DisplayName("Vorbelegung")]
        [HelpText("Wenn der Wert leer ist, wird dieser Wert angezeigt.")]
        [PropertiesGroup("Eigene Einstellungen", 10), PropertiesForm(10)]
        [Translate("")]
        public string DefaultValue { get; set; }

        [DisplayName("Encode HTML")]
        [HelpText("Codiert den HTML Inhalt")]
        [PropertiesGroup("Eigene Einstellungen", 10), PropertiesForm(20)]
        public bool EncodeHTML { get; set; } = true;

        protected override IReadOnlyCollection<EnumDataTypes> GetTypesOfOrmFieldName()
        {
            return new[] { EnumDataTypes.String };
        }

        public override Type GetDataType(GridViewConfiguration gridConfiguration)
        {
            return typeof(string);
        }
    }
}