﻿using BA.Core.Configuration.Navigation;
using BA.Core.Configuration.Navigation.Client;
using BA.Core.CustomAttributes;
using BA.Core.DB;
using BA.Core.Enums;
using BA.Core.Models;
using DevExpress.Web;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Linq.Expressions;

namespace $safeprojectname$.Configuration.Navigation
{
    /// <summary>
    /// Erstellt eine neue Maschine und belegt den Namen und den Betreuer vor. Der Name wird konfiguriert und der
    /// Betreuer ist der aktuelle Anwender.
    /// </summary>
    [Serializable]
    [Toolbox(EnumConfigurationType.NavigationConfigurationGuid, true)]
    [ControlFilter(nameof(NavigationConfiguration.NavigationConfigurationType), ExpressionType.Equal, EnumNavigationConfigurationType.RibbonNavigationGuid, EnumControlFilterApplyState.OptIn)]
    public class ClientActionCreateDefaultEngineRecord : ClientActionBase
    {
        [DisplayName("Vorbelegung Name")]
        public string DefaultName { get; set; }

        public ClientActionCreateDefaultEngineRecord() : base()
        {
            ToolboxName = "Maschine erstellen";
            Caption = "Maschine erstellen";
            ControlInitName = "CreateDefaultEngineRecord";
            ToolboxGroupName = "C007681C-8644-4BB0-A4A0-4A643265EABD";
            Id = "CF3C71FF-C29C-4B02-BE1A-2C9AA1DAA7D1".ToGuid();
            Icon = "industrial_machine";
            IconName = Icon;

            ActionMethodId = "$safeprojectname$.CreateDefaultEngineRecord";
        }

        public override void AdditionalRibbonButtonAssignment(RibbonButtonItem ribbonItem, Dictionary<string, object> additionalClientData, EnumActionVisibleForParentType parentType, DevExUIModelBase uiModel, OrmBABase orm)
        {
            base.AdditionalRibbonButtonAssignment(ribbonItem, additionalClientData, parentType, uiModel, orm);
            additionalClientData.AddOrUpdate("DefaultName", DefaultName);
        }
    }
}