﻿using BA.API;
using BA.Core.MassOperations.Igniters;
using $safeprojectname$.Worker;
using System;
using System.Linq;
using System.Web.Mvc;

namespace $safeprojectname$.Igniters
{
    public class AddServiceWorkerIgniter : OperationOverSelectedRecordsIgniterBase
    {
        public AddServiceWorkerIgniter(IgnitionModel ignitionModel) : base(ignitionModel)
        {
            AllRecordsIfNothingIsSelectedIndicator = false;
            CreateTemporaryRecordsIndicator = true;
            UniqueRecordListIndicator = true;
        }

        /// <inheritdoc/>
        public override ActionResult Ignite()
        {
            if (SomethingSelected)
            {
                // Prüfung ob eine Bemerkung übergeben wurde.
                if (IgnitionModel.Parameters.TryGetValue("RemarkMessage", out object remarkObj) && remarkObj is string remark && !string.IsNullOrWhiteSpace(remark))
                {
                    // Servicedatum setzen.
                    DateTime date;
                    if (IgnitionModel.Parameters.TryGetValue("ServiceDate", out object dateObj) && dateObj is DateTime)
                        date = (DateTime)dateObj;
                    else
                        date = DateTime.Now;

                    // Worker erstellen und in die Queue einreihen
                    Api.Worker.CreateOrUpdate(new AddServiceMassWorker() { Date = date, Remark = remark, TaskExecutionId = TaskExecutionId });
 
                    return null;
                }
                else
                    Api.ClientCommunication.CreateError(Api.User.CurrentUserGuid(), "d49ef787-3ad1-4f66-bb12-b2660fd71738".Translate());
            }

            return null;
        }
    }
}