declare module BA.Ui.Controls {
    class PartialRefreshEvents {
        static PartialRefreshIsSafe: boolean;
        private static _loadingCount;
        private static _conditionChanged;
        /** Timeout handle for the enable-controls timeout */
        private static EnableControlsTimeout;
        /**
        * Called from the partial view callback panel to grab the fields values which should be sent and
        * add some additional data to the request.
        */
        static OnBeginCallback(s: BAClientCallbackPanel, e: any): void;
        /**
         * Partial refresh for all delayed loaded grids
         * @param s control itself
         * @param e callback arguments
         */
        static OnBeginCallbackGrid(s: BAClientCallbackPanel, e: any): void;
        private static _OnlyTheseControls;
        static OnEndCallback(s: BAClientCallbackPanel, e: any): void;
        static OnCallbackError(s: BAClientCallbackPanel, e: ASPxClientCallbackErrorEventArgs): void;
        /**
         * Test if this is object is of type "BAClientGridView" or not.
         * @param x an object
         */
        static isGridView(x: any): x is BAClientGridView;
        /**
         * Test is this is object is of type "BAClientScheduler" or not.
         * @param x an object
         */
        static isScheduler(x: any): x is BAClientScheduler;
        static OnRefreshGroupInit(sender: BAClientCallbackPanel | BAClientGridView | BAClientScheduler, evt: any): void;
        static OnConditionChanged(sender: any, overrideFieldName?: string): void;
        private static GetControlValue;
    }
}
