declare module BA.Ui.Widgets {
    /** Class for Form Widget */
    class FormWidget extends Widget {
        private _alreadyLoaded;
        /** Override of init to attach to resize event */
        Init(): void;
        /**
         * Overrides the default handling of the DefaultFocus on widgets to not do anything: the form does it.
         *
         * @param callback Not used in this case
         */
        DefaultFocus(callback?: Function): void;
        /**
         * On success of the form rendered in the widget all widgets reading data of the orm will be notified of the change.
         */
        OnFormSuccess(): void;
        /**
         * Attach the events needed for the drag and drop interaction of form widgets.
         */
        AttachDragAndDropEvents(): void;
        Unload(): void;
        BeforeRemoving(): boolean;
        /**
         * Overrides the default handling of the OnContentLoaded on widgets.
         */
        OnContentLoaded(): void;
        /**
         * Overrides the standard widget refresh function in order to ask for confirmation if the form has been edited
         *
         * @param blockWidget
         * @param async
         */
        Refresh(blockWidget?: boolean, async?: boolean): void;
        /**
         * Function that is called when UI Settings have been saved
         */
        OnWidgetSettingsDialogClosed(isSuccess: boolean, changesJson: string, triggerContentReload?: boolean): void;
        /**
         * When the widget is expanded the height of the form needs to be adjusted.
         */
        OnExpanded(): void;
        /**
         * When the widget is maximized the height of the form needs to be adjusted.
         */
        OnMaximized(): void;
        /**
         * When the widget's size is restored the height of the form needs to be adjusted.
         */
        OnSizeRestored(): void;
        private OnFormWidgetResized;
        UpdateTabReferenceAndUrl(newUrlAndReference: string): void;
        UpdateParameter(newParameter: Parameters.OrmsWidgetParameter): void;
    }
}
