declare module BA.Ui.Widgets {
    /** Class for previews container widgets */
    class PreviewsContainerWidget extends Widget {
        private _PreviewsVisible;
        Unload(): void;
        /**
         * Attach the events needed for the drag and drop interaction of the previews in previews containter widgets.
         */
        AttachDragAndDropEvents(): void;
        /**
         * When the content is loaded this function initializes the map and adds the corresponding markers.
         */
        OnContentLoaded(): void;
        /**
         * Overrides the standard widget refresh function in order to only update the list instead of the whole
         * widget content.
         *
         * @param blockWidget
         */
        Refresh(blockWidget?: boolean): void;
        /**
        * Function that is called when the widget settings dialog has been closed
        */
        OnWidgetSettingsDialogClosed(isSuccess: boolean, changesJson: string, triggerContentReload?: boolean): void;
        /**
         * Attaches to the preview show and back actions of the given widget.
         *
         * @param $widget
         */
        protected AttachToChildrenEvents($widget: JQuery): void;
        /**
         * Attaches to the preview show and back actions of the given widget.
         *
         * @param $widget
         */
        protected DetachFromChildrenEvents($widget: JQuery): void;
        /**
         * If on is true, this sets the previews container in previews mode, where all the widgets are shown in their preview mode. Otherwise it shows only the
         * given widget.
         *
         * @param on
         * @param $widget
         */
        protected SetContainerPreviewMode(on: boolean, $widget?: JQuery): void;
        /**
         * Actions needed when the given widget is dropped in the previews container.
         *
         * @param widget
         */
        protected OnWidgetDroppedIn(widget: BA.Ui.Widgets.Widget): void;
        /**
         * Actions needed when the given widget is dropped out of the previews container.
         *
         * @param widget
         * @param droppedInAPreviewsContainer
         */
        protected OnWidgetDroppedOut(widget: BA.Ui.Widgets.Widget, droppedInAPreviewsContainer: boolean): void;
    }
}
